namespace XamPivotGridXampl
{
    public class BucketRiskDto
    {
        public string AssetType { get; set; }
        public string AssetId { get; set; }
        public string Book { get; set; }
        public double Risk { get; set; }
        public string Tenor { get; set; }
        public string Curve { get; set; }
        public string Issuer { get; set; }
        public string Currency { get; set; }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj))
            {
                return false;
            }

            if (ReferenceEquals(this, obj))
            {
                return true;
            }

            return GetType() == obj.GetType() && Equals((BucketRiskDto) obj);
        }

        public bool Equals(BucketRiskDto another)
        {
            return AssetType.Equals(another.AssetType)
                   && AssetId.Equals(another.AssetId)
                   && Book.Equals(another.Book)
                   && Risk == another.Risk
                   && Tenor.Equals(another.Tenor)
                   && Curve.Equals(another.Curve)
                   && Issuer.Equals(another.Issuer)
                   && Currency.Equals(another.Currency);
        }

        public override int GetHashCode()
        {
            var hashCode = AssetType.GetHashCodeOrDefault();
            hashCode = (hashCode*397) ^ AssetId.GetHashCodeOrDefault();
            hashCode = (hashCode * 397) ^ Book.GetHashCodeOrDefault();
            hashCode = (hashCode * 397) ^ Risk.GetHashCode();
            hashCode = (hashCode * 397) ^ Tenor.GetHashCodeOrDefault();
            hashCode = (hashCode * 397) ^ Curve.GetHashCodeOrDefault();
            hashCode = (hashCode * 397) ^ Issuer.GetHashCodeOrDefault();
            hashCode = (hashCode * 397) ^ Currency.GetHashCodeOrDefault();

            return hashCode;
        }
    }
}