﻿using System.IO;
using System.Windows;
using Infragistics.Olap;

namespace XamPivotGridXampl
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = new MainWindowViewModel();
        }

        private MainWindowViewModel ViewModel
        {
            get
            {
                return DataContext as MainWindowViewModel;
            }
        }

        private void ButtonRefresh_OnClick(object sender, RoutedEventArgs e)
        {
            ViewModel.Refresh();
        }

        private void ButtonSave_OnClick(object sender, RoutedEventArgs e)
        {
            using (var streamWriter = new StreamWriter(@"C:\Temp\SavedLayout.xml"))
            {
                ViewModel.FlatDataSource.SaveCustomizations(streamWriter.BaseStream);
            }
        }
    }
}
