using System.Linq;
using System.Windows.Data;

namespace XamPivotGridXampl
{
    public class MainWindowViewModel : Bindable
    {
        private readonly BucketRiskFlatDataSource _flatDataSource;

        public MainWindowViewModel() : this(BucketRiskFlatDataSourceFactory.Create(), new BucketRiskLayoutManager())
        {
        }

        internal MainWindowViewModel(BucketRiskFlatDataSource flatDataSource, BucketRiskLayoutManager layoutManager)
        {
            _flatDataSource = flatDataSource;
            LayoutManager = layoutManager;
            BucketRiskLayoutItems = new CompositeCollection {new CollectionContainer {Collection = layoutManager.Layouts}};
        }

        public CompositeCollection BucketRiskLayoutItems { get; private set; }

        public BucketRiskLayoutManager LayoutManager { get; private set; }

        public BucketRiskFlatDataSource FlatDataSource
        {
            get { return _flatDataSource; }
        }

        public void Refresh()
        {
            FlatDataSource.RefreshDataSource(BucketRiskDtoFactory.GetAllExcept754L());
        }
    }
}